Package org.apache.lucene.codecs

## Class KnnVectorsWriter

- java.lang.Object
- - org.apache.lucene.codecs.KnnVectorsWriter

- All Implemented Interfaces:
    `Closeable`, `AutoCloseable`
  Direct Known Subclasses:
    `Lucene92HnswVectorsWriter`

      public abstract class KnnVectorsWriter
      extends Object
      implements Closeable

  Writes vectors to an index.

- - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `KnnVectorsWriter()` | Sole constructor

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `abstract void` | `finish()` | Called once at the end before close
    `void` | `merge​(MergeState mergeState)` | Merges the segment vectors for all fields.
    `abstract void` | `writeField​(FieldInfo fieldInfo, KnnVectorsReader knnVectorsReader)` | Write all values contained in the provided reader

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.io.Closeable

      `close`

- - ### Constructor Detail

    - #### KnnVectorsWriter

          protected KnnVectorsWriter()

      Sole constructor

  - ### Method Detail

    - #### writeField

          public abstract void writeField​(FieldInfo fieldInfo,
                                          KnnVectorsReader knnVectorsReader)
                                   throws IOException

      Write all values contained in the provided reader
      Throws:
        `IOException`

    - #### finish

          public abstract void finish()
                               throws IOException

      Called once at the end before close
      Throws:
        `IOException`

    - #### merge

          public void merge​(MergeState mergeState)
                     throws IOException

      Merges the segment vectors for all fields. This default implementation delegates to `writeField(org.apache.lucene.index.FieldInfo, org.apache.lucene.codecs.KnnVectorsReader)`, passing a `KnnVectorsReader` that combines the vector values and ignores deleted documents.
      Throws:
        `IOException`